"use strict";
const {classes: Cc, interfaces: Ci, utils: Cu, Constructor: CC} = Components;
var SettingsDocumentHelper = {
GUI_NS: "http://bar.yandex.ru/dev/native/gui",
HTML_NS: "http://www.w3.org/1999/xhtml",
createPreferencesNodes: function Helpers_createPreferencesNodes(aDocument, aSettingsDocument) {
var preferenceIDs = [];
var docFrag = aDocument.createDocumentFragment();
var prefNodes = aSettingsDocument.getElementsByTagName("preference");
for (let i = prefNodes.length;i--;) {
let id = prefNodes[i].id;
if (id)
{
preferenceIDs.push(id);
if (! aDocument.getElementById(id))
docFrag.appendChild(prefNodes[i]);
}

}

var prefNode = aSettingsDocument.getElementsByTagName("preferences")[0];
if (prefNode)
prefNode.parentNode.removeChild(prefNode);
if (docFrag.childNodes.length)
aDocument.documentElement.currentPane.getElementsByTagName("preferences")[0].appendChild(docFrag);
return preferenceIDs;
}
,
importNodes: function Helpers_importNodes(aDocument, aSettingsDocument, aNodeName, aNodeNameSpace, aReqAttributes) {
Array.slice(aSettingsDocument.getElementsByTagNameNS(aNodeNameSpace,aNodeName)).forEach(function (aNode) {
if (aNodeName == "style" && aNode.hasAttribute("src"))
{
let stylesElement = aDocument.getElementById("YaSubPrefController-styles");
if (! stylesElement)
{
Preferences._logger.error("element.@src (" + aNode.getAttribute("src") + ") " + "is not supported in the main document.");
return;
}

let stylesheet = stylesElement.sheet;
stylesheet.insertRule("@import url('" + aNode.getAttribute("src") + "');",stylesheet.cssRules.length);
return;
}

var clone = aDocument.createElementNS(aNodeNameSpace,aNodeName);
Array.slice(aNode.attributes).forEach(function (attr) {
if (attr.name == "src")
{
if (aDocument === document)
{
Preferences._logger.error("element.@src (" + aNode.getAttribute("src") + ") " + "is not supported in the main document.");
return;
}

clone.setAttribute(attr.name,aNode.src || attr.value);
}
 else
{
clone.setAttribute(attr.name,attr.value);
}

}
);
for(let [attrName, attrValue] in Iterator(aReqAttributes)) if (! clone.hasAttribute(attrName))
clone.setAttribute(attrName,attrValue);
clone.textContent = aNode.textContent;
aDocument.documentElement.appendChild(clone);
}
);
}
,
createNativeNodes: function Helpers_createNativeNodes(aDocument, aSettingsDocument, aContainer) {
if (! aContainer.hasAttribute("xb-custom-prefs-inited"))
{
aContainer.setAttribute("xb-custom-prefs-inited","true");
if (aSettingsDocument)
{
this.importNodes(aDocument,aSettingsDocument,"script",this.HTML_NS,{
type: "application/x-javascript"});
this.importNodes(aDocument,aSettingsDocument,"style",this.HTML_NS,{
type: "text/css"});
}

}

var nativeNodesData = {
__proto__: null,
_nodesWithName: {
__proto__: null},
_nodesWithoutName: [],
hasNamedNode: function nativeNodesData_hasNamedNode(aName) {
return aName in this._nodesWithName;
}
,
appendNamedNodes: function nativeNodesData_appendNamedNodes(aContainer, aName, aPrefPath, aDefaultValue) {
if (! this.hasNamedNode(aName))
return false;
this._nodesWithName[aName].forEach(function (element) {
aContainer.appendChild(element);
if (aPrefPath && element.nodeType == Node.ELEMENT_NODE)
{
[element].concat(Array.slice(element.getElementsByAttribute("preference","%pref%"))).forEach(function _makePrefNode(el) {
this._makePrefNode(el,aName,aPrefPath,aDefaultValue);
}
,this);
}

}
,this);
delete this._nodesWithName[aName];
return true;
}
,
appendNodes: function nativeNodesData_appendNodes(aContainer) {
for each(let nodes in this._nodesWithName) nodes.forEach(function (element) aContainer.appendChild(element));
delete this._nodesWithName;
this._nodesWithoutName.forEach(function (element) aContainer.appendChild(element));
delete this._nodesWithoutName;
}
,
_makePrefNode: function nativeNodesData__makePrefNode(aElement, aName, aPrefPath, aDefaultValue) {
if (aElement.getAttribute("preference") != "%pref%")
return;
if (aDefaultValue !== null)
aElement.setAttributeNS(SettingsDocumentHelper.GUI_NS,"xbDefaultValue",aDefaultValue);
var doc = aElement.ownerDocument;
var prefNode = doc.getElementById(aPrefPath);
if (! prefNode)
{
prefNode = doc.createElement("preference");
prefNode.setAttributeNS(SettingsDocumentHelper.GUI_NS,"preftype","custom");
prefNode.setAttribute("id",aPrefPath);
prefNode.setAttribute("name",aPrefPath);
doc.documentElement.currentPane.getElementsByTagName("preferences")[0].appendChild(prefNode);
}

aElement.setAttribute("preference",aPrefPath);
setTimeout(function () prefNode.updateElements(),0);
}
};
if (aSettingsDocument)
{
let guiNode = aSettingsDocument.getElementsByTagNameNS(this.GUI_NS,"gui")[0];
if (guiNode)
{
let guiBlockNodes = guiNode.getElementsByTagNameNS(this.GUI_NS,"nodes");
Array.slice(guiBlockNodes).forEach(function (aNodesBlock) {
var name = aNodesBlock.getAttribute("name");
var nodesData = name ? (nativeNodesData._nodesWithName[name] = []) : nativeNodesData._nodesWithoutName;
Array.slice(aNodesBlock.childNodes).forEach(function (aNode) {
var node = aDocument.importNode(aNode,true);
nodesData.push(node);
}
);
}
);
let handlers = {
onshown: "onSettingsShown",
onhidden: "onSettingsHidden",
onapply: "onSettingsApply",
oncancel: "onSettingsCancel",
onreset: "onSettingsReset"};
for(let [key, val] in Iterator(handlers)) if (guiNode.hasAttribute(key))
aContainer.setAttribute(val,guiNode.getAttribute(key));
}

}

return nativeNodesData;
}
};
var SettingsProxy = {
_valuesHash: Object.create(null),
clear: function SettingsProxy_clear() {
this._valuesHash = Object.create(null);
}
,
remember: function SettingsProxy_remember(widgetId, settingName, settingValue) {
if (! (widgetId in this._valuesHash))
this._valuesHash[widgetId] = {
};
this._valuesHash[widgetId][settingName] = settingValue;
}
,
recall: function SettingsProxy_recall(widgetId, settingName) {
if (widgetId in this._valuesHash && settingName in this._valuesHash[widgetId])
return this._valuesHash[widgetId][settingName];
return undefined;
}
,
__iterator__: function SettingsProxy_iterator() {
for(let [widgetId, widgetSettingsData] in Iterator(this._valuesHash)) for(let [settingName, settingValue] in Iterator(widgetSettingsData)) yield [widgetId, settingName, settingValue];
}
,
resetAll: function SettingsProxy_resetAll() {
try {
Preferences.barCore.Lib.Preferences.resetBranch(Preferences.barCore.xbWidgetsPrefsPath);
Preferences.barCore.Lib.Preferences.resetBranch(Preferences.barCore.nativesPrefsPath);
}
catch (e) {

}

}
};
window.WidgetsJS = Object.create(null);
function WidgetProxy(aProtoId) {
this._id = aProtoId;
this.isXbWidget = true;
this.type = null;
this.disabled = false;
this._init();
}

WidgetProxy.prototype = {
_init: function WidgetProxy__init() {
if (StaticWidgets.hasWidget(this._id))
{
this.type = "static";
let widget = StaticWidgets.getWidget(this._id);
this.isXbWidget = false;
this.iconURL = widget.iconURL;
this.isUnique = widget.isUnique;
this.isRemovable = false;
this._id = widget.protoId;
this.protoId = widget.protoId;
this.name = widget.name;
}
 else
{
this.type = "widget";
let widgetInfo = this.widgetInfo;
this.iconURL = widgetInfo.iconPath ? widgetInfo.package_.resolvePath(widgetInfo.iconPath) : "";
this.isUnique = widgetInfo.isUnique;
this.isRemovable = ! Preferences.barCore.application.widgetLibrary.isPreinstalledWidget(this._id);
this.protoId = this._id;
this.name = widgetInfo.name;
}

}
,
get widgetInfo() {
return Preferences.barCore.application.widgetLibrary.getWidgetInfo(this._id);
}
,
get id() {
return this._id;
}
};
function WidgetInstProxy(aInstanceID) {
this.isXbWidget = true;
this.type = null;
this.disabled = false;
this._id = aInstanceID;
this._preferenceIDs = [];
this._init();
}

WidgetInstProxy.prototype = {
_init: function WidgetInstProxy__init() {
if (StaticWidgets.hasWidget(this._id))
{
this.type = "static";
let widget = StaticWidgets.getWidget(this._id);
this.isXbWidget = false;
this.iconURL = widget.iconURL;
this.isUnique = widget.isUnique;
this.isRemovable = false;
this.protoId = widget.protoId;
this.instanceID = this._id;
this.name = widget.name;
this._settingsXULDocument = widget.settingsXULDocument;
this._preferenceIDs = widget.preferenceIDs;
}
 else
{
this.type = "widget";
let xbWidget = this.xbWidget;
let proto = xbWidget.prototype;
this.iconURL = proto.iconURI;
this.isUnique = proto.isUnique;
this.isRemovable = false;
this.protoId = proto.id;
this.instanceID = this.widgetInfo.instanceID;
this.name = proto.name;
}

}
,
_settingsXULDocument: undefined,
get settingsXULDocument() {
if (typeof this._settingsXULDocument == "undefined")
{
this._settingsXULDocument = this.isXbWidget ? this._createSettingsXULDocument("main",document) : this._settingsXULDocument;
}

return this._settingsXULDocument;
}
,
getSubSettingsXULDocument: function WidgetInstProxy_getSubSettingsXULDocument(aDocument) {
return this.isXbWidget ? this._createSettingsXULDocument("sub",aDocument) : null;
}
,
onSettingsRestore: function WidgetInstProxy_onSettingsRestore() {
this._settingsXULDocument = undefined;
}
,
makeURL: function WidgetInstProxy_makeURL(aSpec) {
var spec = /^https?:\/\//.test(aSpec) ? aSpec : this.unitPackage.resolvePath(aSpec);
var uri = spec ? Preferences.barCore.Lib.misc.tryCreateFixupURI(spec) : null;
if (! (uri && /^(https?|xb)$/.test(uri.scheme) && uri.spec))
return "";
return uri.spec;
}
,
get id() {
return this._id;
}
,
get packageId() {
return this.unitPackage.id;
}
,
get widgetInfo() {
return Preferences.overlayProvider.parseWidgetItemId(this._id);
}
,
get xbWidget() {
return Preferences._widgetHost.getWidget(this.widgetInfo.instanceID);
}
,
get unitPackage() {
return this.xbWidget.prototype.unit.unitPackage;
}
,
get protoSettings() {
return this.xbWidget.prototype.widgetSettings;
}
,
get instanceSettings() {
return this.xbWidget.instanceSettings;
}
,
get packageSettings() {
return this.xbWidget.prototype.packageSettings;
}
,
get nativeModule() {
return this.xbWidget.prototype.nativeModule || null;
}
,
updatePreferenceNodes: function WidgetInstProxy_updatePreferenceNodes(aDocument) {
this._preferenceIDs.forEach(function (aID) {
var prefNode = aDocument.getElementById(aID);
if (prefNode)
prefNode.updateElements();
}
);
}
,
_createSettingsXULDocument: function WidgetInstProxy__createSettingsXULDocument(aType, aDocument) {
Preferences._logger.debug("WidgetInstProxy__createSettingsXULDocument: " + [aType, aDocument]);
var nativeModule = this.nativeModule;
var getTemplateFunctionName = aType == "sub" ? "getSubTemplate" : "getMainTemplate";
var moduleSettings = nativeModule && nativeModule.core.Settings;
if (! (moduleSettings && getTemplateFunctionName in moduleSettings))
return null;
var settingsTemplate;
try {
settingsTemplate = moduleSettings[getTemplateFunctionName](this.name,this.instanceID);
}
catch (ex) {
Preferences._logger.error(ex);
}

if (settingsTemplate instanceof Ci.nsIInputStream)
settingsTemplate = Preferences.barCore.Lib.fileutils.readStringFromStream(settingsTemplate);
if (aType == "main" && typeof settingsTemplate == "object")
{
let label = "";
if ("subwindowControl" in settingsTemplate)
{
let subwindowControl = settingsTemplate.subwindowControl;
if ("label" in subwindowControl)
label = " label value=\"" + subwindowControl.label + "\"";
}

settingsTemplate = "<?xml version=\"1.0\"?>                 <gui:component xmlns=\"http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul\"                                xmlns:gui=\"" + SettingsDocumentHelper.GUI_NS + "\">                     <gui:gui>                         <gui:nodes>                             <vbox class=\"subwindow-opener\"" + label + "/>                         </gui:nodes>                     </gui:gui>                 </gui:component>";
}

if (! (typeof settingsTemplate == "string" && settingsTemplate))
return null;
var cryptoHash = Preferences.barCore.Lib.misc.CryptoHash;
var packageIdHash = cryptoHash.getFromString(this.packageId,"MD5");
var protoIdHash = cryptoHash.getFromString(this.protoId,"MD5");
var instanceIdHash = cryptoHash.getFromString(this.instanceID,"MD5");
var jsNativeModuleObjectPrefix = "_wgtNativeModule_" + protoIdHash;
var jsNativeModuleDefinedObjectPrefix = "_defined_" + jsNativeModuleObjectPrefix;
if (! (jsNativeModuleObjectPrefix in WidgetsJS))
{
let me = this;
WidgetsJS.__defineGetter__(jsNativeModuleObjectPrefix,function __WJS_nativeModuleGetter() {
if (! (jsNativeModuleDefinedObjectPrefix in this))
this[jsNativeModuleDefinedObjectPrefix] = me.nativeModule;
return this[jsNativeModuleDefinedObjectPrefix];
}
);
}

var jsPackageObjectPrefix = "_wgtPackage_" + packageIdHash;
var jsPackageDefinedObjectPrefix = "_defined_" + jsPackageObjectPrefix;
if (! (jsPackageObjectPrefix in WidgetsJS))
{
WidgetsJS.__defineGetter__(jsPackageObjectPrefix,function __WJS_packageObjectGetter() {
return this[jsPackageDefinedObjectPrefix];
}
);
WidgetsJS.__defineSetter__(jsPackageObjectPrefix,function __WJS_packageObjectSetter(aObject) {
if (! (jsPackageDefinedObjectPrefix in this))
this[jsPackageDefinedObjectPrefix] = aObject;
}
);
}

var jsProtoObjectPrefix = "_wgtProto_" + protoIdHash;
var jsProtoDefinedObjectPrefix = "_defined_" + jsProtoObjectPrefix;
if (! (jsProtoObjectPrefix in WidgetsJS))
{
WidgetsJS.__defineGetter__(jsProtoObjectPrefix,function __WJS_protoObjectGetter() {
return this[jsProtoDefinedObjectPrefix];
}
);
WidgetsJS.__defineSetter__(jsProtoObjectPrefix,function __WJS_protoObjectSetter(aObject) {
if (! (jsProtoDefinedObjectPrefix in this))
this[jsProtoDefinedObjectPrefix] = aObject;
}
);
}

var globalObjectPrefix = (aType == "sub" ? "window.opener." : "") + "WidgetsJS.";
var xbPackageURL = this.unitPackage.resolvePath("");
var nativeComponents = Preferences.barCore.application.NativeComponents;
var packagePrefBranch = nativeComponents.makePackagePrefPath(this.unitPackage.id);
var protoPrefBranch = nativeComponents.makeWidgetPrefPath(this.protoId);
settingsTemplate = settingsTemplate.replace(/((var|let)\s*)?JSNativeModule/gm,globalObjectPrefix + jsNativeModuleObjectPrefix).replace(/((var|let)\s*)?JSPackageObject/gm,globalObjectPrefix + jsPackageObjectPrefix).replace(/((var|let)\s*)?JSProtoObject/gm,globalObjectPrefix + jsProtoObjectPrefix).replace(/\{\{UNIC_STR\}\}/gm,"uniq" + instanceIdHash).replace(/\{\{PROTO_ID\}\}/gm,this.protoId).replace(/\{\{PACKAGE_PREF_BRANCH\}\}/gm,packagePrefBranch).replace(/\{\{PROTO_PREF_BRANCH\}\}/gm,protoPrefBranch).replace(/\{\{PACKAGE_URL\}\}/gm,xbPackageURL);
if (this.type == "widget")
{
let jsInstObjectPrefix = "_wgtInst_" + instanceIdHash;
let jsInstDefinedObjectPrefix = "_defined_" + jsInstObjectPrefix;
if (! (jsInstObjectPrefix in WidgetsJS))
{
WidgetsJS.__defineGetter__(jsInstObjectPrefix,function __WJS_instObjectGetter() {
return this[jsInstDefinedObjectPrefix];
}
);
WidgetsJS.__defineSetter__(jsInstObjectPrefix,function __WJS_instObjectSetter(aObject) {
if (! (jsInstDefinedObjectPrefix in this))
this[jsInstDefinedObjectPrefix] = aObject;
}
);
}

let instancePrefBranch = nativeComponents.makeInstancePrefPath(this.protoId,this.instanceID);
settingsTemplate = settingsTemplate.replace(/\{\{INST_PREF_BRANCH\}\}/gm,instancePrefBranch).replace(/\{\{INST_ID\}\}/gm,this.instanceID).replace(/((var|let)\s*)?JSInstObject/gm,globalObjectPrefix + jsInstObjectPrefix);
}

var uri = Preferences._ioService.newURI(xbPackageURL,null,null);
var domParser = Preferences.barCore.Lib.xmlutils.getDOMParser(uri,uri,true);
var xulDocument;
try {
settingsTemplate = settingsTemplate.replace(/>\s*</gim,"><");
xulDocument = domParser.parseFromString(settingsTemplate,"text/xml");
let docElement = xulDocument.documentElement;
if (docElement.localName == "parsererror")
throw new Error("An error occured while parsing widget settings UI.");
if (docElement.localName != "component" || docElement.namespaceURI != SettingsDocumentHelper.GUI_NS)
throw new Error("Wrong settings UI structure.");
}
catch (ex) {
Preferences._logger.error(ex);
Preferences._logger.debug("Settings template:\n" + settingsTemplate);
return null;
}

SettingsDocumentHelper.createPreferencesNodes(aDocument,xulDocument).forEach(function (id) {
if (this.indexOf(id) == - 1)
this.push(id);
}
,this._preferenceIDs);
return xulDocument;
}
};
function PluginInstProxy(aPlugin) {
this.isXbWidget = true;
this.type = "plugin";
this._id = aPlugin._id;
this._preferenceIDs = [];
this._plugin = aPlugin;
this._init();
}

PluginInstProxy.prototype = {
_init: function PluginInstProxy__init() {
var widgetInfo = this.widgetInfo;
this.iconURL = widgetInfo.iconPath ? widgetInfo.package_.resolvePath(widgetInfo.iconPath) : "";
this.isUnique = widgetInfo.isUnique;
this.isRemovable = ! Preferences.barCore.application.widgetLibrary.isPreinstalledPlugin(this._id);
this.protoId = widgetInfo.id;
this.instanceID = widgetInfo.id;
this.name = widgetInfo.name;
this.startupDisabledState = this.disabled;
}
,
get disabled() {
return ! this._plugin.enabled;
}
,
set disabled(val) {
this._plugin.enabled = ! val;
}
,
get id() {
return this._id;
}
,
get widgetInfo() {
return this._plugin._unit.componentInfo;
}
,
get xbWidget() {
return this._plugin;
}
,
get unitPackage() {
return this.widgetInfo.package_;
}
,
get protoSettings() {
return {
};
}
,
get instanceSettings() {
return this._plugin.pluginSettings;
}
,
get packageSettings() {
return this._plugin.packageSettings;
}
,
get nativeModule() {
return this._plugin._module;
}
,
_settingsXULDocument: undefined,
get settingsXULDocument() {
if (typeof this._settingsXULDocument == "undefined")
{
this._settingsXULDocument = this._createSettingsXULDocument("main",document);
}

return this._settingsXULDocument;
}
,
getSubSettingsXULDocument: WidgetInstProxy.prototype.getSubSettingsXULDocument,
makeURL: WidgetInstProxy.prototype.makeURL,
updatePreferenceNodes: WidgetInstProxy.prototype.updatePreferenceNodes,
onSettingsRestore: WidgetInstProxy.prototype.onSettingsRestore,
_createSettingsXULDocument: WidgetInstProxy.prototype._createSettingsXULDocument};
var WidgetsBase = {
remove: function WidgetsBase_remove(aWidgetID) {
var widgets = this._widgets;
for (let i = 0, len = widgets.length;i < len;i++) {
if (widgets[i].id == aWidgetID)
return widgets.splice(i,1)[0];
}

return null;
}
,
__iterator__: function WidgetsBase_iterator() {
var widgets = this._widgets;
for (let i = 0, len = widgets.length;i < len;i++) yield widgets[i];
}
,
onSettingsRestore: function WidgetsBase_onSettingsRestore() {
this._widgets.forEach(function (widget) widget.onSettingsRestore());
}
};
var RegisteredWidgets = {
__proto__: WidgetsBase,
_widgets: [],
push: function RegisteredWidgets_push(aProtoID, aBeforeID) {
var widget;
try {
widget = new WidgetProxy(aProtoID);
}
catch (e) {
Preferences._logger.error("Could not create widget proxy (protoID = " + aProtoID + "). " + Preferences.barCore.Lib.strutils.formatError(e));
return null;
}

this._widgets.push(widget);
return RegisteredWidgetsController.insertItem(widget,aBeforeID);
}
,
get: function RegisteredWidgets_get(aProtoID) {
return this._widgets.filter(function (wp) wp.id == aProtoID)[0];
}
};
var ActiveWidgets = {
__proto__: WidgetsBase,
_widgets: [],
push: function ActiveWidgets_push(aInstanceID, aBeforeID) {
var widget;
try {
widget = new WidgetInstProxy(aInstanceID);
}
catch (e) {
Preferences._logger.error("Could not create widget proxy (instanceID = " + aInstanceID + "). " + Preferences.barCore.Lib.strutils.formatError(e));
return null;
}

this._widgets.push(widget);
return ActiveWidgetsController.insertItem(widget,aBeforeID);
}
,
get: function ActiveWidgets_get(aInstanceID) {
return this._widgets.filter(function (wp) wp.id == aInstanceID || wp.instanceID == aInstanceID)[0];
}
};
var RegisteredPlugins = {
__proto__: WidgetsBase,
_widgets: [],
push: function RegisteredPlugins_push(aPlugin, aBeforeID) {
var widget;
try {
widget = new PluginInstProxy(aPlugin);
}
catch (e) {
Preferences._logger.error("Could not create plugin proxy. " + Preferences.barCore.Lib.strutils.formatError(e));
return null;
}

this._widgets.push(widget);
return RegisteredPluginsController.insertItem(widget,aBeforeID);
}
,
get: function RegisteredPlugins_get(aInstanceID) {
return this._widgets.filter(function (wp) wp.id == aInstanceID)[0];
}
};
var StaticWidgets = {
_specialIDs: {
"proto": ["separator", "spacer", "spring"],
"localNames": ["toolbarseparator", "toolbarspacer", "toolbarspring"],
"names": {
}},
getSpecialID: function StaticWidgets_getSpecialID(aID) {
var id = aID.replace(/(\d+)$/,"");
if (this._specialIDs.proto.indexOf(id) > - 1)
return id;
return null;
}
,
clear: function StaticWidgets_clear() {
this._knowIDs = [];
}
,
init: function StaticWidgets_init() {
this.clear();
this._specialIDs.proto.forEach(function (name) {
this[name] = Preferences.getString(name);
}
,this._specialIDs.names);
var toolbarNodes = Array.slice(Preferences._setupWndCtrl.appToolbar.childNodes);
for (let i = toolbarNodes.length;i-- > 0;) {
if (this._specialIDs.localNames.indexOf(toolbarNodes[i].localName) > - 1)
{
this._knowIDs.push(toolbarNodes[i].id);
}

}

}
,
_knowIDs: [],
get knownIDs() {
return this._knowIDs;
}
,
get knownProtoIDs() {
return this._knowIDs.filter(function (id) ! this.getSpecialID(id),this).concat(this._specialIDs.proto);
}
,
hasWidget: function StaticWidgets_hasWidget(aWidgetID) {
return this.getSpecialID(aWidgetID) || this.knownIDs.indexOf(aWidgetID) != - 1;
}
,
getWidget: function StaticWidgets_getWidget(aWidgetID) {
var widgetID = this.getSpecialID(aWidgetID);
var name = this._specialIDs.names[widgetID] || "widget";
return {
protoId: widgetID + "-proto",
iconURL: "",
isUnique: false,
name: name,
settingsXULDocument: null,
preferenceIDs: []};
}
};
var ProductBranding = {
shutdown: function ProductBranding_shutdown() {
this.partnerPackSvc = null;
}
,
get libraryLink() {
var linkElement = this._productData.productXML.querySelector("LibraryURL");
delete this.libraryLink;
return this.libraryLink = {
url: linkElement && this._replaceURLTemplates(linkElement.textContent),
action: linkElement && linkElement.getAttribute("action")};
}
,
get hasLibLink() {
try {
return ! ! this.libraryLink.url;
}
catch (e) {
return false;
}

}
,
get homepageName() {
var homepageName = "";
var hpElement;
try {
hpElement = this._productData.browserXML.querySelector("Browser > HomePage");
}
catch (e) {

}

if (hpElement)
{
homepageName = hpElement.getAttribute("title");
if (! homepageName)
{
let urlString = this._replaceURLTemplates(hpElement.textContent);
if (urlString)
{
let uri;
try {
uri = Preferences._ioService.newURI(urlString,null,null);
homepageName = uri.host;
}
catch (e) {
try {
homepageName = uri.spec;
}
catch (e) {
Preferences._logger.error("Can't get homepage address from '" + hpElement.textContent + "'");
}

}

}

}

}

delete this.homepageName;
return this.homepageName = homepageName;
}
,
setBrowserHomePage: function ProductBranding_setBrowserHomePage() {
Preferences.barCore.application.installer.setBrowserHomePage();
}
,
PARTNER_PACK_COMPID: "ru.yandex.custombar.branding",
PARTNER_PACK_SVCNAME: "package",
_partnerPackSvc: null,
get partnerPackSvc() {
if (this._partnerPackSvc === null)
{
let nativeComps = Preferences.barCore.application.NativeComponents;
let service = nativeComps.obtainService(this.PARTNER_PACK_COMPID,this.PARTNER_PACK_SVCNAME,this,"ru.yandex.bar.preferences");
this._partnerPackSvc = service;
}

return this._partnerPackSvc;
}
,
set partnerPackSvc(aValue) {
if (this._partnerPackSvc)
{
let nativeComps = Preferences.barCore.application.NativeComponents;
nativeComps.releaseService(this.PARTNER_PACK_COMPID,this.PARTNER_PACK_SVCNAME,this);
}

this._partnerPackSvc = aValue;
}
,
observeServiceEvent: function ProductBranding_observeServiceEvent() {

}
,
get _productData() {
var productXML = this.partnerPackSvc.getXMLDocument("/about/product.xml");
var browserXML = this.partnerPackSvc.getXMLDocument("/browser/browserconf.xml");
delete this._productData;
return this._productData = {
productXML: productXML,
browserXML: browserXML};
}
,
_replaceURLTemplates: function ProductBranding__replaceURLTemplates(aURL) {
return this.partnerPackSvc.expandBrandTemplatesEscape(aURL);
}
};
var Preferences = {
barCore: Cc["@yandex.ru/custombarcore;" + XB_APP_NAME].getService().wrappedJSObject,
_domParserConstructor: new CC("@mozilla.org/xmlextras/domparser;1", "nsIDOMParser", "init"),
_ioService: Cc["@mozilla.org/network/io-service;1"].getService(Ci.nsIIOService),
_setupWndCtrl: null,
_widgetHost: null,
get _logger() {
delete this._logger;
return this._logger = this.barCore.application.getLogger("Preferences");
}
,
_restoreInfo: {
currentset: {
},
collapsed: null},
_panesInfo: {
_data: {
__proto__: null,
_started: false,
_selectComponentOnLoad: null},
get started() {
return this._data._started;
}
,
set started(aValue) {
this._data._started = ! ! aValue;
}
,
isPaneStarted: function PanesInfo_isPaneStarted(aPaneType) {
return aPaneType in this._data;
}
,
setPaneStarted: function PanesInfo_setPaneStarted(aPaneType, aIsStarted) {
if (aIsStarted)
this._data[aPaneType] = true; else
delete this._data[aPaneType];
}
,
getComponentForSelect: function PanesInfo_getComponentForSelect(aPaneType) {
var selectionData = this._selectComponentOnLoad;
if (selectionData)
{
if (selectionData.type == aPaneType)
this._selectComponentOnLoad = null; else
selectionData = null;
}

return selectionData;
}
,
setComponentForSelect: function PanesInfo_setComponentForSelect(aPaneType, aComponentId) {
this._selectComponentOnLoad = {
type: aPaneType,
componentId: aComponentId};
}
},
_initPane: function Preferences__initPane(aPaneID) {
var paneElement = document.getElementById(aPaneID);
if (! paneElement)
return;
if (document.documentElement.currentPane != paneElement)
document.documentElement.showPane(paneElement);
if (! paneElement.loaded)
return;
if (paneElement.getAttribute("xb-pane-ready") == "true")
return;
this._logger.trace("Init pane: " + aPaneID);
switch (aPaneID) {
case "prefpane-widgets":
let libraryLinkBox = document.getElementById("library-link-box");
if (libraryLinkBox)
libraryLinkBox.hidden = ! ProductBranding.hasLibLink;
case "prefpane-plugins":
setTimeout(function Preferences__initPaneTimed() Preferences._startPane(aPaneID),0);
break;
case "prefpane-about":
aboutDlg.onDialogLoad();
break;
case "prefpane-misc":
YaSearchPrefs.onPaneLoad();
break;
}

paneElement.setAttribute("xb-pane-ready","true");
}
,
_startPane: function Preferences__startPane(aPaneID) {
var paneType = aPaneID.replace(/^prefpane\-/,"");
if (this._panesInfo.isPaneStarted(paneType))
return;
this._panesInfo.setPaneStarted(paneType,true);
if (! this._panesInfo.started)
{
this._panesInfo.started = true;
this._setupWndCtrl = this.gBrowser[XB_APP_NAME + "OverlayController"];
this._widgetHost = this._setupWndCtrl.widgetHost;
this.overlayProvider = this.barCore.application.overlayProvider;
this._rememberToolbarsCurrentSet();
let toolbar = this._setupWndCtrl.appToolbar;
this._restoreInfo.collapsed = toolbar.collapsed;
toolbar.setForceHideAttribute();
toolbar.collapsed = false;
let doc = toolbar.ownerDocument;
let evt = doc.createEvent("Event");
evt.initEvent(XB_APP_NAME + "-beforecustomization",true,true);
this._setupWndCtrl._toolbox.dispatchEvent(evt);
}

switch (paneType) {
case "widgets":
this._initWidgetsPane();
break;
case "plugins":
this._initPluginsPane();
break;
}

var componentForSelect = this._panesInfo.getComponentForSelect(paneType);
if (componentForSelect)
this._selectComponent(componentForSelect.type,componentForSelect.componentId);
document.documentElement.setAttribute("buttondisabledextra2","false");
}
,
openSubDialog: function Preferences_openSubDialog(aObject) {
var widgetInstanceId = null;
if (aObject instanceof Ci.nsIDOMElement)
{
let parentListItem = aObject;
while (parentListItem && ! widgetInstanceId) {
if (parentListItem.localName == "richlistitem")
widgetInstanceId = parentListItem.id; else
parentListItem = parentListItem.parentNode;
}

}
 else
if (typeof aObject == "string")
{
widgetInstanceId = aObject;
}

var widget = widgetInstanceId && (ActiveWidgets.get(widgetInstanceId) || RegisteredPlugins.get(widgetInstanceId));
if (! widget)
{
this._logger.error("Open sub dialog: can't find widget.");
return;
}

var subDialogArgs = {
Preferences: Preferences,
SettingsDocumentHelper: SettingsDocumentHelper,
widget: widget};
document.documentElement.openSubDialog(this.prefDirChromePath + "/preferences-subwin.xul","",subDialogArgs);
}
,
_initPluginsPane: function Preferences__initPluginsPane() {
this._fillPluginsLists();
}
,
_fillPluginsLists: function Preferences__fillPluginsLists() {
RegisteredPluginsController.init();
this.barCore.application.widgetLibrary.getPlugins().forEach(function (aPlugin) RegisteredPlugins.push(aPlugin));
}
,
deletePlugins: function Preferences_deletePlugins() {
var selectedItems = Array.slice(RegisteredPluginsController.list.selectedItems);
if (! selectedItems.length)
return;
var removableItems = selectedItems.filter(function (aItem) aItem.isRemovable);
if (! removableItems.length)
return;
if (! this._confirmComponentsDeletion(removableItems,"plugins"))
return;
var barApp = this.barCore.application;
var pluginIDsToRemove = [];
var checkPackages = Object.create(null);
removableItems.forEach(function (aItem) {
var protoId = aItem.getAttribute("id");
RegisteredPluginsController.removeItem(protoId);
var plugin = RegisteredPlugins.remove(protoId);
try {
plugin.disabled = true;
}
catch (e) {
let strutils = this.barCore.Lib.strutils;
this._logger.error(strutils.formatString("Could not turn plugin (%1) on. %2",[protoId, strutils.formatError(e)]));
}

var [packageID] = barApp.BarPlatform.parseComponentID(protoId);
checkPackages[packageID] = true;
pluginIDsToRemove.push(protoId);
}
,this);
barApp.widgetLibrary.forgetPlugins(pluginIDsToRemove,true);
barApp.widgetLibrary.persist(false,true);
for(let packageID in checkPackages) {
this._logger.debug("Checking package " + packageID);
if (! barApp.widgetLibrary.getComponentsInfo(packageID).length)
{
barApp.packageManager.uninstallPackage(packageID,true);
barApp.widgetLibrary.cleanPackageParserCache(packageID);
}

}

}
,
_initWidgetsPane: function Preferences__initWidgetsPane() {
this._fillWidgetsLists();
this.gDocument.addEventListener("DOMNodeInserted",WidgetNodesMutationListener,false);
this.gDocument.addEventListener("DOMNodeRemoved",WidgetNodesMutationListener,false);
var palette = this._setupWndCtrl._toolbox.palette;
palette.addEventListener("DOMNodeInserted",WidgetNodesMutationListener,false);
palette.addEventListener("DOMNodeRemoved",WidgetNodesMutationListener,false);
}
,
selectComponent: function Preferences_selectComponent(aInstanceID, aPaneType) {
if (typeof aPaneType == "string")
{
let prefpanes = document.documentElement.preferencePanes;
for (let i = 0, len = prefpanes.length;i < len;i++) {
if (prefpanes[i].id == "prefpane-" + aPaneType)
{
this._initPane("prefpane-" + aPaneType);
return;
}

}

this._logger.error("No such pane (\"" + aPaneType + "\").");
return;
}

var paneType = this.barCore.application.widgetLibrary.isKnownPlugin(aInstanceID) ? "plugins" : "widgets";
if (! this._panesInfo.isPaneStarted(paneType))
{
this._panesInfo.setComponentForSelect(paneType,aInstanceID);
this._initPane("prefpane-" + paneType);
}
 else
{
this._selectComponent(paneType,aInstanceID);
}

}
,
_selectComponent: function Preferences__selectComponent(aPaneType, aInstanceID) {
if (! aInstanceID)
return;
if (! this._panesInfo.isPaneStarted(aPaneType))
{
this._logger.error("Prefpane \"" + aPaneType + "\" is not started.");
return;
}

switch (aPaneType) {
case "widgets":
let widget = ActiveWidgets.get(aInstanceID);
if (widget)
{
ActiveWidgetsController.selectItem(widget);
ActiveWidgetsController.list.focus();
}
 else
this._logger.error("Select widget: can't find widget for " + aInstanceID);
break;
case "plugins":
let plugin = RegisteredPlugins.get(aInstanceID);
if (plugin)
{
RegisteredPluginsController.selectItem(plugin);
RegisteredPluginsController.list.focus();
}
 else
this._logger.error("Select widget: can't find plugin for " + aInstanceID);
break;
default:
break;
}

this.checkControls();
}
,
_fillWidgetsLists: function Preferences__fillWidgetsLists() {
RegisteredWidgetsController.init();
ActiveWidgetsController.init();
StaticWidgets.init();
function addToRegisteredWidgets(aProtoID) {
if (["http://bar.yandex.ru/packages/yandexbar#separator", "http://bar.yandex.ru/packages/yandexbar#spring", "http://bar.yandex.ru/packages/yandexbar#spacer"].indexOf(aProtoID) != - 1)
return;
try {
RegisteredWidgets.push(aProtoID);
}
catch (e) {
this._logger.error("Failed in Preferences__fillWidgetsLists. " + this.barCore.Lib.strutils.formatError(e));
this._logger.debug(e.stack);
}

}

var knownXBIDs = this.barCore.application.widgetLibrary.getAvaibleWidgetIDs();
var knownStaticIDs = [].concat(StaticWidgets.knownProtoIDs);
var defaultWidgets = this.barCore.application.defaultPreset.widgetEntries;
for (let i = 0, len = defaultWidgets.length;i < len;i++) {
let protoID = defaultWidgets[i].componentID;
let index = - 1;
if ((index = knownXBIDs.indexOf(protoID)) != - 1)
{
knownXBIDs.splice(index,1);
addToRegisteredWidgets(protoID);
}

}

knownXBIDs.forEach(function (protoID) addToRegisteredWidgets(protoID));
knownStaticIDs.forEach(function (protoID) addToRegisteredWidgets(protoID));
this.getAllWidgetItems().forEach(function (aToolbarItem) ActiveWidgets.push(aToolbarItem.id));
}
,
_finalize: function Preferences__finalize() {
var doc = this._setupWndCtrl._toolbox.ownerDocument;
var evt = doc.createEvent("Event");
evt.initEvent(XB_APP_NAME + "-aftercustomization",true,true);
this._setupWndCtrl._toolbox.dispatchEvent(evt);
this._logger.trace("Finalize");
RegisteredWidgetsController.finalize();
ActiveWidgetsController.finalize();
RegisteredPluginsController.finalize();
WidgetsJS = null;
this.overlayProvider = null;
this._widgetHost = null;
this._setupWndCtrl = null;
this._logger = null;
}
,
get instantApply() {
delete this.instantApply;
return this.instantApply = document.documentElement.instantApply;
}
,
_accepted: false,
beforeAccept: function Preferences_beforeAccept() {
try {
if (! this._accepted)
{
this._apply();
this._accepted = true;
}

}
catch (e) {
this._logger.error("Could not apply changes. " + this.barCore.Lib.strutils.formatError(e));
this._logger.debug(e.stack);
}

return true;
}
,
onUnload: function Preferences_onUnload() {
ProductBranding.shutdown();
try {
if (this._gBrowser)
this._gBrowser.removeEventListener("unload",this,false);
}
catch (ex) {

}

if (this._panesInfo.isPaneStarted("widgets"))
{
try {
this.gDocument.removeEventListener("DOMNodeInserted",WidgetNodesMutationListener,false);
this.gDocument.removeEventListener("DOMNodeRemoved",WidgetNodesMutationListener,false);
let palette = this._setupWndCtrl._toolbox.palette;
palette.removeEventListener("DOMNodeInserted",WidgetNodesMutationListener,false);
palette.removeEventListener("DOMNodeRemoved",WidgetNodesMutationListener,false);
}
catch (e) {
this._logger.error("Failed in Preferences_onUnload. " + this.barCore.Lib.strutils.formatError(e));
}

}

if (! this._panesInfo.isPaneStarted("widgets") && ! this._panesInfo.isPaneStarted("plugins"))
return;
try {
if (this.instantApply)
this.beforeAccept();
if (! this._accepted)
this._cancel();
this._finalize();
}
catch (e) {
this._logger.error("Failed in Preferences_onUnload. " + this.barCore.Lib.strutils.formatError(e));
}

}
,
_apply: function Preferences__apply() {
YaSearchPrefs.onDialogAccept();
ActiveWidgetsController.onDialogApply();
RegisteredPluginsController.onDialogApply();
this._logger.debug("Applying");
if (this._panesInfo.isPaneStarted("widgets"))
{
this.getAllWidgetItems().forEach(function (aToolbarItem) {
try {
let customizeState = aToolbarItem.getAttribute("xb-customize");
if (customizeState)
{
aToolbarItem.removeAttribute("xb-customize");
if (customizeState == "removed")
{
this.barCore.application.forEachWindow(function (controller) {
try {
controller.removeItemById(aToolbarItem.id,true);
}
catch (e) {
this._logger.error(this.barCore.Lib.strutils.formatError(e));
this._logger.debug(e.stack);
}

}
,this);
}

}

}
catch (ex) {
this._logger.error(ex);
}

}
,this);
}

for(let [componentId, settingName, settingValue] in Iterator(SettingsProxy)) {
let component = ActiveWidgets.get(componentId) || RegisteredPlugins.get(componentId);
if (! component)
{
this._logger.warn("Could not apply setting. Component " + componentId + " not found.");
continue;
}

component.xbWidget.applySetting(settingName,settingValue);
}

if (this._pluginsStateChanged)
{
this.barCore.application.widgetLibrary.persist(false,true);
}

SettingsProxy.clear();
if (this._panesInfo.isPaneStarted("widgets"))
{
if (this._restoreInfo.collapsed)
{
let toolbar = this._setupWndCtrl.appToolbar;
if (this._restoreInfo.currentset[toolbar.id] != toolbar.currentSet)
{
toolbar.collapsed = false;
this._restoreInfo.collapsed = false;
}
 else
{
toolbar.collapsed = this._restoreInfo.collapsed;
}

toolbar.ownerDocument.persist(toolbar.id,"collapsed");
}

this._persistToolbarsSet();
}

}
,
_cancel: function Preferences__cancel() {
this._logger.debug("Reverting");
ActiveWidgetsController.onDialogCancel();
RegisteredPluginsController.onDialogCancel();
if (this._panesInfo.isPaneStarted("widgets"))
{
if (this._restoreInfo.collapsed)
this._setupWndCtrl.appToolbar.collapsed = true;
this._restoreToolbarsCurrentSet();
}

if (this._panesInfo.isPaneStarted("plugins"))
{
for(let plugin in Iterator(RegisteredPlugins)) {
if (plugin.startupDisabledState != plugin.disabled)
{
plugin.disabled = ! plugin.disabled;
}

}

}

}
,
restoreDefault: function Preferences_restoreDefault() {
if (! this._getUserConfirm(this.getString("PreferencesTitle"),this.getString("RestoreDefaultSet")))
return;
ActiveWidgetsController.onDialogReset();
RegisteredPluginsController.onDialogReset();
var obsService = Cc["@mozilla.org/observer-service;1"].getService(Ci.nsIObserverService);
obsService.notifyObservers(null,this.barCore.eventTopics.EVT_BEFORE_GLOBAL_RESET,null);
Array.slice(document.getElementsByTagName("preferences")).forEach(function (aPrefsElement) {
if (/#childprefs$/.test(aPrefsElement.id))
aPrefsElement.parentNode.removeChild(aPrefsElement);
}
);
const UNDEF = undefined;
var prefNodes = document.getElementsByTagName("preference");
for (let i = prefNodes.length;i--;) {
if (prefNodes[i].getAttributeNS(SettingsDocumentHelper.GUI_NS,"resetOnRestore") == "true")
{
try {
prefNodes[i].valueFromPreferences = UNDEF;
}
catch (ex) {

}

}

}

var items = this.getAllWidgetItems();
for (let i = items.length;i-- > 0;) {
let item = items[i];
if (item.hasAttribute("xb-customize"))
item.removeAttribute("xb-customize");
try {
this._setupWndCtrl.removeItem(item,true);
}
catch (e) {
this._logger.error(e);
}

}

var toolbox = this.gDocument.getElementById("navigator-toolbox");
if (toolbox)
toolbox.removeAttribute("cb-barless");
this.barCore.application.BarPlatform.eraseSettings();
this.barCore.application.widgetLibrary.setDefaultPluginsState();
var toolbar = this._setupWndCtrl.appToolbar;
toolbar.multiline = false;
toolbar.onToolbarCustomize(true);
this._setupWndCtrl.applyPreset(this.barCore.application.defaultPreset,"hard",undefined,true);
this._setupWndCtrl.checkNeedSetBarlessMode();
toolbar.collapsed = false;
if (toolbar.mClassicMode)
{
toolbar.ownerDocument.persist(toolbar.id,"collapsed");
this._restoreInfo.collapsed = false;
}
 else
{
this._restoreInfo.collapsed = true;
}

this._persistToolbarsSet();
SettingsProxy.clear();
for(let prop in WidgetsJS) delete WidgetsJS[prop];
ActiveWidgets.onSettingsRestore();
RegisteredPlugins.onSettingsRestore();
if (this._panesInfo.isPaneStarted("widgets"))
this._fillWidgetsLists();
if (this._panesInfo.isPaneStarted("plugins"))
this._fillPluginsLists();
this._rememberToolbarsCurrentSet();
Preferences.barCore.application.updater.resetUpdatesThrottling();
obsService.notifyObservers(null,this.barCore.eventTopics.EVT_AFTER_GLOBAL_RESET,null);
}
,
_getToolbarsCurrentSet: function Preferences__getToolbarsCurrentSet() {
var toolbarsCurrentset = {
};
var toolbars = this.gDocument.getElementsByTagName("toolbar");
for (let i = toolbars.length;i-- > 0;) {
let toolbar = toolbars[i];
let id = toolbar.id;
if (! id)
continue;
toolbarsCurrentset[id] = toolbar.currentSet;
}

return toolbarsCurrentset;
}
,
_rememberToolbarsCurrentSet: function Preferences__rememberToolbarsCurrentSet() {
this._restoreInfo.currentset = this._getToolbarsCurrentSet();
}
,
_restoreToolbarsCurrentSet: function Preferences__restoreToolbarsCurrentSet() {
this._checkModifiedToolbaritemsOnRestore();
var toolbarsRememberedInfo = this._restoreInfo.currentset;
for(let [toolbarId, toolbarInfo] in Iterator(this._getToolbarsCurrentSet())) {
let prevCurrentSet = toolbarsRememberedInfo[toolbarId];
if (! prevCurrentSet)
continue;
let toolbar = this.gDocument.getElementsByAttribute("id",toolbarId).item(0);
if (! toolbar)
continue;
if (prevCurrentSet !== toolbar.currentSet)
{
let restoredSet = prevCurrentSet || toolbar.getAttribute("defaultset") || "";
Preferences._logger.trace(["Restored currentset for #" + toolbarId, restoredSet].join("\n"));
toolbar.currentSet = restoredSet;
toolbar.ownerDocument.persist(toolbarId,"currentset");
}

}

this._rememberToolbarsCurrentSet();
}
,
_checkModifiedToolbaritemsOnRestore: function Preferences__checkModifiedToolbaritemsOnRestore() {
var selectors = "[xb-customize='removed'], [xb-customize='added']";
var items = this.gDocument.querySelectorAll(selectors);
var setupWndCtrl = this._setupWndCtrl;
for (let i = items.length;i-- > 0;) {
let item = items.item(i);
try {
if (item.getAttribute("xb-customize") == "added")
setupWndCtrl.removeItem(item,true);
item.removeAttribute("xb-customize");
}
catch (e) {
this._logger.error(e);
}

}

}
,
_getSiblingNode: function Preferences__getSiblingNode(aNode, aDirection, aIncludeForeignToolbars) {
var toolbar = aIncludeForeignToolbars && aNode && aNode.parentNode;
var node = this.__getSiblingNode(aNode,aDirection);
while (! node && toolbar) {
toolbar = this._getSiblingToolbar(toolbar,aDirection);
node = toolbar && this._getChildNode(toolbar,aDirection == "next" ? "first" : "last");
}

return node;
}
,
__getSiblingNode: function Preferences___getSiblingNode(aNode, aDirection) {
var directionProp = aDirection + "Sibling";
var node = aNode && aNode[directionProp];
while (node && (node.getAttribute("xb-customize") == "removed" || node.hidden)) node = node[directionProp];
return node;
}
,
_getChildNode: function Preferences__getChildNode(aParent, aType) {
var node = aType == "first" ? aParent.firstChild : aParent.lastChild;
if (node && (node.getAttribute("xb-customize") == "removed" || node.hidden))
node = this._getSiblingNode(node,aType == "first" ? "next" : "previous");
return node;
}
,
_getFirstChild: function Preferences__getFirstChild(aParent) {
return this._getChildNode(aParent,"first");
}
,
_getLastChild: function Preferences__getLastChild(aParent) {
return this._getChildNode(aParent,"last");
}
,
_getSiblingToolbar: function Preferences__getSiblingToolbar(aToolbar, aDirection) {
var navToolbox = this.gDocument.getElementById("navigator-toolbox");
if (! navToolbox)
return null;
var toolbarNodes = Array.slice(navToolbox.childNodes);
toolbarNodes.push(this.gDocument.getElementById("addon-bar"));
toolbarNodes = toolbarNodes.filter(function (t) {
if (! t)
return false;
if (! t.getAttribute("toolbarname"))
return false;
if (t.collapsed || t.hidden || t.getAttribute("id") == "toolbar-menubar")
return false;
return true;
}
);
var curIndex = toolbarNodes.indexOf(aToolbar);
curIndex += aDirection == "next" ? 1 : - 1;
return curIndex >= 0 && toolbarNodes[curIndex] || null;
}
,
_checkControlsTimeout: null,
checkControls: function Preferences_checkControls() {
if (this._checkControlsTimeout)
window.clearTimeout(this._checkControlsTimeout);
this._checkControlsTimeout = setTimeout(function (me) {
if (me && "_checkControls" in me)
me._checkControls();
}
,0,this);
}
,
_checkControls: function Preferences__checkControls() {
switch (document.documentElement.currentPane.id) {
case "prefpane-widgets":
this.checkWidgetsControls();
break;
case "prefpane-plugins":
this.checkPluginsControls();
break;
}

}
,
_checkWidgetsControlsTimeout: null,
checkWidgetsControls: function Preferences_checkWidgetsControls() {
if (this._checkWidgetsControlsTimeout)
window.clearTimeout(this._checkWidgetsControlsTimeout);
this._checkWidgetsControlsTimeout = setTimeout(function (me) {
if (me && "_checkWidgetsControls" in me)
me._checkWidgetsControls();
}
,0,this);
}
,
_checkWidgetsControls: function Preferences__checkWidgetsControls() {
var canAddWidgets = ! ! RegisteredWidgetsController.list.selectedCount;
document.getElementById("canAddWidgetsBroadcaster").setAttribute("disabled",! canAddWidgets);
var canDeleteWidgets = false;
var focusedElement = document.commandDispatcher.focusedElement;
if (! focusedElement || focusedElement != ActiveWidgetsController.list)
{
let selectedItems = Array.slice(RegisteredWidgetsController.list.selectedItems);
canDeleteWidgets = ! ! selectedItems.some(function (aItem) aItem.isRemovable);
}

document.getElementById("canDeleteWidgetsBroadcaster").setAttribute("disabled",! canDeleteWidgets);
var activeList = ActiveWidgetsController.list;
var canRemoveWidgets = ! ! activeList.selectedCount;
document.getElementById("canRemoveWidgetsBroadcaster").setAttribute("disabled",! canRemoveWidgets);
var canMoveUp = canRemoveWidgets;
var canMoveDown = canRemoveWidgets;
document.getElementById("canMoveWidgetsUpBroadcaster").setAttribute("disabled",! canMoveUp);
document.getElementById("canMoveWidgetsDownBroadcaster").setAttribute("disabled",! canMoveDown);
}
,
_checkPluginsControlsTimeout: null,
checkPluginsControls: function Preferences_checkPluginsControls() {
if (this._checkPluginsControlsTimeout)
window.clearTimeout(this._checkPluginsControlsTimeout);
this._checkPluginsControlsTimeout = setTimeout(function (me) {
if (me && "_checkPluginsControls" in me)
me._checkPluginsControls();
}
,0,this);
}
,
_checkPluginsControls: function Preferences__checkPluginsControls() {
var selectedItems = Array.slice(RegisteredPluginsController.list.selectedItems);
var canDeletePlugins = ! ! selectedItems.some(function (aItem) aItem.isRemovable);
document.getElementById("canDeletePluginsBroadcaster").setAttribute("disabled",! canDeletePlugins);
}
,
selectAll: function Preferences_selectAll() {
var focusedElement = document.commandDispatcher.focusedElement;
if (focusedElement && focusedElement.localName == "richlistbox")
{
if ("expandItem" in focusedElement && focusedElement.currentItem)
focusedElement.expandItem(null);
focusedElement.selectAll();
}

}
,
addWidgets: function Preferences_addWidgets(aNodeBefore) {
var selectedItems = Array.slice(RegisteredWidgetsController.list.selectedItems);
var beforeId = aNodeBefore ? aNodeBefore.id : null;
var addedItems = [];
for (let i = 0, len = selectedItems.length;i < len;i++) {
let addedItem = this._addWidget(selectedItems[i],beforeId);
if (addedItem)
addedItems.push(addedItem);
}

var addedLength = addedItems.length;
if (addedLength)
{
let firstSelectedItem = addedItems[0];
let lastSelectedItem = addedItems[addedLength - 1];
let activeList = ActiveWidgetsController.list;
activeList.selectItemRange(firstSelectedItem,lastSelectedItem);
if (addedLength == 1)
{
firstSelectedItem.click();
}
 else
{
activeList.ensureElementIsVisible(lastSelectedItem);
activeList.ensureElementIsVisible(firstSelectedItem);
}

}

}
,
_addWidget: function Preferences__addWidget(aListItem, aRelativeElementId) {
function insertToolbarItem(aToolbar, aExistsElement, aRelativeElement) {
if (aExistsElement)
return aRelativeElement ? destToolbar.insertBefore(aExistsElement,aRelativeElement) : destToolbar.appendChild(aExistsElement);
return null;
}

var relativeElement = aRelativeElementId ? this.gDocument.getElementById(aRelativeElementId) : null;
var destToolbar = relativeElement ? relativeElement.parentNode : this._setupWndCtrl.appToolbar;
var toolbaritem;
var widget = RegisteredWidgets.get(aListItem.id);
if (widget.isXbWidget)
{
if (widget.isUnique)
{
let existsToolbaritem = this.gDocument.querySelector("toolbaritem[cb-app='" + XB_APP_NAME + "'][cb-proto-id='" + widget.protoId + "']");
toolbaritem = insertToolbarItem(destToolbar,existsToolbaritem,relativeElement);
}

if (! toolbaritem)
[, toolbaritem] = this._setupWndCtrl.placeWidget(widget.protoId,relativeElement,false,"no");
}
 else
{
let toolbaritemId = widget.protoId.replace(/\-proto/,"");
if (widget.isUnique)
{
let existsToolbaritem = this.gDocument.getElementById(toolbaritemId);
toolbaritem = insertToolbarItem(destToolbar,existsToolbaritem,relativeElement);
}

toolbaritem = toolbaritem || destToolbar.insertItem(toolbaritemId,relativeElement);
}

if (! toolbaritem)
return null;
toolbaritem.setAttribute("xb-customize","added");
var relativeElementIdForList = aRelativeElementId;
if (! relativeElementIdForList)
{
let allItems = this.getAllWidgetItems();
for (let i = 0, len = allItems.length;i < len;i++) {
if (allItems[i] !== toolbaritem)
continue;
let nextItem = allItems[i + 1];
if (nextItem && nextItem.id)
relativeElementIdForList = nextItem.id;
break;
}

}

return ActiveWidgets.push(toolbaritem.id,relativeElementIdForList);
}
,
removeWidgets: function Preferences_removeWidgets(aListItems, aRemovePermanently) {
var itemsToRemove = typeof aListItems == "undefined" ? Array.slice(ActiveWidgetsController.list.selectedItems) : aListItems;
if (! itemsToRemove)
return;
for (let i = itemsToRemove.length;i-- > 0;) this._removeWidget(itemsToRemove[i],aRemovePermanently);
}
,
_removeWidget: function Preferences__removeWidget(aListItem, aRemovePermanently) {
var toolbaritemId = aListItem.id;
var toolbaritem = this.gDocument.getElementById(toolbaritemId);
if (toolbaritem)
{
if (aRemovePermanently)
{
try {
this._setupWndCtrl.removeItem(toolbaritem,true);
}
catch (e) {
this._logger.error(e);
}

}
 else
{
toolbaritem.setAttribute("xb-customize","removed");
}

}

ActiveWidgetsController.removeItem(aListItem);
var widget = ActiveWidgets.remove(toolbaritemId);
RegisteredWidgetsController.setWidgetVisibility(widget.protoId,"visible");
}
,
moveWidgets: function Preferences_moveWidgets(aDirection, aRelativeElement) {
var selectedItems = ActiveWidgetsController.list.selectedItemsSorted;
if (! selectedItems)
return;
var placeAfter = aDirection === "down";
var len = selectedItems.length;
var selectedItem = placeAfter ? selectedItems[len - 1] : selectedItems[0];
var toolbaritem = this.gDocument.getElementById(selectedItem.id);
if (! toolbaritem || toolbaritem.id == (aRelativeElement && aRelativeElement.id))
return;
var parentToolbar = toolbaritem.parentNode;
var relativeElement;
var relativeAppElement;
function _getRelatedAppElement(elem, direction) {
var allKnownItems = Preferences.getAllWidgetItems();
var r = elem;
while (r && (allKnownItems.indexOf(r) == - 1 || selectedItems.some(function (s) s.id == r.id))) r = Preferences._getSiblingNode(r,direction == "up" ? "previous" : "next",true);
return r;
}

if (aDirection)
{
relativeElement = this._getSiblingNode(toolbaritem,aDirection == "up" ? "previous" : "next",true);
if (placeAfter)
{
relativeElement = this._getSiblingNode(relativeElement,"next",true);
}
 else
if (! relativeElement)
{
return;
}

relativeAppElement = _getRelatedAppElement(relativeElement,"next");
}
 else
if (aRelativeElement)
{
relativeElement = this.gDocument.getElementById(aRelativeElement.id);
relativeAppElement = relativeElement;
}

ActiveWidgetsController.moveSelectedItems(aDirection,relativeAppElement && relativeAppElement.id);
var toolbar = relativeElement && relativeElement.parentNode || this._setupWndCtrl.appToolbar;
var doc = toolbar.ownerDocument;
var docFrag = doc.createDocumentFragment();
var next = toolbaritem.nextSibling;
selectedItems.forEach(function (aListItem) {
var toolbaritem = doc.getElementById(aListItem.id);
if (toolbaritem)
{
if (placeAfter && toolbaritem.nextSibling)
next = toolbaritem.nextSibling;
docFrag.appendChild(toolbaritem);
}

}
);
if (next && ! (next.parentNode && next.parentNode.localName))
next = null;
if (placeAfter)
{
if (next)
{
if (next === next.parentNode.lastChild)
{
relativeElement = null;
toolbar = next.parentNode;
}

}
 else
{
let nextToolbar = this._getSiblingToolbar(parentToolbar,"next");
if (nextToolbar && toolbar !== nextToolbar)
{
relativeElement = nextToolbar.firstChild || null;
toolbar = nextToolbar;
}

}

}
 else
{
if (! next || next === next.parentNode.firstChild)
{
let previousToolbar = this._getSiblingToolbar(parentToolbar,"previous");
if (previousToolbar)
{
toolbar = previousToolbar;
relativeElement = toolbar.lastChild || null;
}

}

}

if (relativeElement === toolbaritem && next)
relativeElement = next;
relativeElement ? toolbar.insertBefore(docFrag,relativeElement) : toolbar.appendChild(docFrag);
this.checkWidgetsControls();
var selectedLen = selectedItems.length;
var activeList = ActiveWidgetsController.list;
if (selectedLen > 1)
activeList.ensureElementIsVisible(selectedItems[selectedItems.length - 1]);
activeList.ensureElementIsVisible(selectedItems[0]);
}
,
deleteWidgets: function Preferences_deleteWidgets() {
var selectedItems = Array.slice(RegisteredWidgetsController.list.selectedItems);
if (! selectedItems.length)
return;
var removableItems = selectedItems.filter(function (aItem) aItem.isRemovable);
if (! removableItems.length)
return;
if (! this._confirmComponentsDeletion(removableItems,"widgets"))
return;
var barApp = this.barCore.application;
var widgetsProtoToRemove = [];
var checkPackages = Object.create(null);
removableItems.forEach(function (aItem) {
var protoId = aItem.getAttribute("id");
var activeItems = ActiveWidgetsController.getItemsForProto(protoId);
this.removeWidgets(activeItems,true);
RegisteredWidgetsController.removeItem(protoId);
RegisteredWidgets.remove(protoId);
barApp.forEachWindow(function (controller) controller.removeWidgetsOfProto(protoId));
var [packageID] = barApp.BarPlatform.parseComponentID(protoId);
checkPackages[packageID] = true;
widgetsProtoToRemove.push(protoId);
}
,this);
barApp.widgetLibrary.forgetWidgets(widgetsProtoToRemove,true);
barApp.widgetLibrary.persist(true,false);
var changedPackages = [packageID for (packageID in checkPackages)];
barApp.forEachWindow(function (controller) controller.updatePalette(changedPackages));
for(let packageID in checkPackages) {
this._logger.debug("Checking package " + packageID);
if (! barApp.widgetLibrary.getComponentsInfo(packageID).length)
{
barApp.packageManager.uninstallPackage(packageID,true);
barApp.widgetLibrary.cleanPackageParserCache(packageID);
}

}

}
,
switchPluginState: function Preferences_switchPluginState(aPluginId) {
RegisteredPluginsController.switchItemState(aPluginId);
this._pluginsStateChanged = true;
}
,
_pluginsStateChanged: false,
_persistToolbarsSet: function Preferences__persistToolbarsSet(aToolbox) {
if (this._setupWndCtrl._toolbox.customizing)
return;
if (! window.persistCurrentSets)
return;
var toolbox = aToolbox || this.gDocument.getElementById("navigator-toolbox");
var n = {
gToolboxChanged: true,
gToolbox: toolbox,
gToolboxDocument: toolbox.ownerDocument};
var o = {
};
for(let p in n) {
o[p] = window[p];
window[p] = n[p];
}

window.persistCurrentSets();
for(let p in o) window[p] = o[p];
}
,
getAllWidgetItems: function Preferences_getAllWidgetItems() {
var toolbarID = this._setupWndCtrl.appToolbar.id;
var selectors = ["toolbaritem[cb-app='" + XB_APP_NAME + "']", "toolbar[id='" + toolbarID + "'] toolbarseparator", "toolbar[id='" + toolbarID + "'] toolbarspring", "toolbar[id='" + toolbarID + "'] toolbarspacer"].concat(StaticWidgets.knownIDs.map(function (id) "toolbaritem[id='" + id + "']")).join(", ");
return Array.slice(this.gDocument.querySelectorAll(selectors));
}
,
getItemFromDocumentOrPalette: function Preferences_getItemFromDocumentOrPalette(aWidgetID) {
return this.gDocument.getElementById(aWidgetID) || this._setupWndCtrl._toolbox.palette.getElementsByAttribute("id",aWidgetID).item(0);
}
,
_gBrowser: null,
get gBrowser() {
if (! this._gBrowser)
{
let misc = this.barCore.Lib.misc;
let browser = misc.getTopBrowserWindow();
if (! browser)
{
window.open("about:blank","_blank");
browser = misc.getTopBrowserWindow();
window.focus();
}

if (! browser)
throw new Error("Can't create browser for preferences window.");
browser.addEventListener("unload",this,false);
this._gBrowser = browser;
}

return this._gBrowser;
}
,
get gDocument() {
return this.gBrowser.document;
}
,
_prefDirChromePath: null,
get prefDirChromePath() {
if (! this._prefDirChromePath)
this._prefDirChromePath = document.documentURI.split("/preferences.xul")[0];
return this._prefDirChromePath;
}
,
_transformXML: function Preferences__transformXML(aXML, aStylesheet) {
if (! (aXML && aStylesheet))
return null;
var xsltProcessor = Cc["@mozilla.org/document-transformer;1?type=xslt"].createInstance(Ci.nsIXSLTProcessor);
var result = null;
try {
xsltProcessor.importStylesheet(aStylesheet);
let ownerDocument = document.implementation.createDocument("","xb-prefs",null);
result = xsltProcessor.transformToFragment(aXML,ownerDocument);
}
catch (ex) {
this._logger.error("Can't transform XML. " + ex);
}

if (! result || result.documentElement && result.documentElement.localName == "parsererror")
{
this._logger.trace("Can't transform XML.");
result = null;
}

return result;
}
,
get _controlsStylesheet() {
var fileutils = this.barCore.Lib.fileutils;
var addonFS = this.barCore.application.addonFS;
var stylesheetStream = addonFS.getStream("$content/preferences/templates/controls.xsl");
var styleSheet = fileutils.xmlDocFromStream(stylesheetStream,null,null,true);
delete this._controlsStylesheet;
return this._controlsStylesheet = styleSheet;
}
,
transformControlXML: function Preferences_transformControlXML(aControlXML) {
var result = this._transformXML(aControlXML,this._controlsStylesheet);
return result ? result.firstChild : null;
}
,
_parseSourceXMLData: function Preferences__parseSourceXMLData(aWidget, aData) {
if (! (aData && aData.data))
return null;
try {
let path = aData.url && /^xb:\/\//.test(aData.url) ? aData.url : aWidget.unitPackage.resolvePath("");
let uri = this._ioService.newURI(path,null,null);
let domParser = new this._domParserConstructor(null, uri, uri);
return domParser.parseFromString(aData.data,"text/xml");
}
catch (ex) {
this._logger.error(ex);
}

return null;
}
,
transformSourceXMLData: function Preferences_transformSourceXMLData(aInstanceID, aType, aXMLData, aXSLData) {
var widget = ActiveWidgets.get(aInstanceID);
if (! widget)
return null;
var xmlData = this._parseSourceXMLData(widget,aXMLData);
if (! xmlData)
return null;
if (aXSLData)
{
try {
let stylesheet = this._parseSourceXMLData(widget,aXSLData);
xmlData = this._transformXML(xmlData,stylesheet);
}
catch (ex) {
xmlData = null;
}

if (! xmlData)
return null;
}

var result;
try {
let type = aType.indexOf("shortcuts") == - 1 ? "source" : "shortcuts";
let fileutils = this.barCore.Lib.fileutils;
let addonFS = this.barCore.application.addonFS;
let styleSheet = fileutils.xmlDocFromStream(addonFS.getStream("$content/preferences/templates/controls-" + type + ".xsl"),null,null,true);
result = this._transformXML(xmlData,styleSheet);
}
catch (ex) {
this._logger.error(ex);
}

if (! result)
{
this._logger.trace("Can't transform XML data for control.");
return null;
}

this._logger.trace("Preferences.transformControlXMLData\n");
return result;
}
,
onPrefChange: function Preferences_onPrefChange(aItem, aPrefName, aPrefValue) {
var widget = ActiveWidgets.get(aItem.id) || RegisteredPlugins.get(aItem.id);
if (! (widget && widget.isXbWidget))
return;
if (this.instantApply)
widget.xbWidget.applySetting(aPrefName,aPrefValue); else
SettingsProxy.remember(widget.id,aPrefName,aPrefValue);
}
,
doCommand: function Preferences_doCommand(aCommand, aArguments) {
try {
switch (aCommand) {
case "cmd_addWidgets":
this.addWidgets(aArguments);
break;
case "cmd_remove":
switch (document.documentElement.currentPane.id) {
case "prefpane-widgets":
this.removeWidgets();
break;
case "prefpane-plugins":
this.deletePlugins();
break;
}

break;
case "cmd_moveWidgetsUp":
this.moveWidgets("up");
break;
case "cmd_moveWidgetsDown":
this.moveWidgets("down");
break;
case "cmd_moveWidgets":
this.moveWidgets(null,aArguments);
break;
case "cmd_restoreDefault":
this.restoreDefault();
break;
case "cmd_selectAll":
this.selectAll();
break;
case "cmd_deleteWidgets":
this.deleteWidgets();
break;
case "cmd_deletePlugins":
this.deletePlugins();
break;
case "cmd_switchPluginState":
this.switchPluginState(aArguments);
break;
default:
break;
}

}
catch (e) {
this._logger.error("Could not complete command " + aCommand + ". " + this.barCore.Lib.strutils.formatError(e));
this._logger.debug(e.stack);
}

}
,
handleEvent: function Preferences_handleEvent(aEvent) {
try {
this._handleEvent.apply(this,arguments);
}
catch (e) {
this._logger.error(this.barCore.Lib.strutils.formatError(e));
this._logger.debug(e.stack);
}

}
,
_handleEvent: function Preferences__handleEvent(aEvent) {
switch (aEvent.type) {
case "load":
this.barCore.application.componentsUsage.logCustomAction("http://bar.yandex.ru/packages/yandexbar#settings",1);
aEvent.currentTarget.removeEventListener("load",this,false);
["width", "height"].forEach(function (aAttrName) {
if (this.hasAttribute("min" + aAttrName) && this.hasAttribute(aAttrName))
{
let minval = parseInt(this.getAttribute("min" + aAttrName),10);
let realval = parseInt(this.getAttribute(aAttrName),10);
if (realval && minval)
{
let val = Math.max(minval,realval);
if (minval > realval)
this.setAttribute(aAttrName,val);
if (aAttrName == "height")
window.outerHeight = val; else
if (aAttrName == "width")
window.outerWidth = val;
}

}

}
,document.documentElement);
let locAnchor = window.location.toString().split("#")[1];
let [instanceID, paneType] = window.arguments || [];
if (instanceID !== undefined || paneType !== undefined || ! ! locAnchor)
this.selectComponent(instanceID,paneType || locAnchor);
break;
case "paneload":
document.documentElement.__defineGetter__("_shouldAnimate",function () false);
this._initPane(aEvent.target.id);
break;
case "unload":
document.documentElement.cancelDialog();
break;
default:
break;
}

}
,
_confirmComponentsDeletion: function Preferences__confirmComponentsDeletion(aItems, aItemsType) {
const maxComponentsInTitle = 6;
const maxComponentLabelLength = parseInt(180 / Math.min(aItems.length,maxComponentsInTitle),10);
function getShortItemLabel(aItem) {
var label = aItem.getAttribute("label");
if (label.length > maxComponentLabelLength)
{
label = label.substr(0,maxComponentLabelLength).replace(/(\s+\S{0,5})$/,"") + "...";
}

return label;
}

var componentsLabel = (aItems.length > maxComponentsInTitle ? aItems.slice(0,maxComponentsInTitle - 1) : aItems).map(function (aItem) getShortItemLabel(aItem));
var moreText = componentsLabel.length == aItems.length ? "" : " " + this.getString("DeleteComponentsAndOthers");
componentsLabel = "«" + componentsLabel.join("», «") + "»" + moreText;
var stringPrefix = "Delete" + this.barCore.Lib.strutils.camelize("-" + aItemsType);
var confirmTitle = this.getStringPlural(stringPrefix + "Title",[aItems.length]);
var confirmText = this.getStringPlural(stringPrefix + "Text",[aItems.length],[componentsLabel]);
return this._getUserConfirm(confirmTitle,confirmText);
}
,
_getUserConfirm: function Preferences__getUserConfirm(aTitle, aText) {
return Cc["@mozilla.org/embedcomp/prompt-service;1"].getService(Ci.nsIPromptService).confirm(window,aTitle,aText);
}
,
get _stringBundle() {
delete this._stringBundle;
return this._stringBundle = new Preferences.barCore.application.appStrings.StringBundle("preferences/preferences.properties");
}
,
getString: function Preferences_getString(aName, aArgs) {
return this._stringBundle.get(aName,aArgs);
}
,
getStringPlural: function Preferences_getStringPlural(aName, aArgs, aPluralData) {
return this._stringBundle.getPlural(aName,aArgs,aPluralData);
}
,
openLibraryLink: function Preferences_openLibraryLink() {
var link = ProductBranding.libraryLink;
if (! link.url)
return;
this.barCore.Lib.misc.navigateBrowser({
url: link.url,
target: "new tab"});
if (link.action)
barApp.componentsUsage.logShortAction(link.action);
document.documentElement.acceptDialog();
window.close();
}
,
onConfidentialBlockClick: function Preferences_onConfidentialBlockClick(aEvent) {
if (aEvent.target.localName == "a")
{
let domain = "legal.yandex.ru";
switch (this.barCore.application.branding.productInfo.BrandID.toString()) {
case "ua":
domain = "legal.yandex.ua";
break;
case "tb":
domain = "legal.yandex.com.tr";
break;
}

let url = aEvent.target.href.replace(/\/legal\.yandex\.[^\/]+\//,"/" + domain + "/");
this.barCore.Lib.misc.navigateBrowser({
url: url,
target: "new tab"});
document.documentElement.acceptDialog();
window.close();
return false;
}

document.getElementById("send-usage-stat-checkbox").click();
return false;
}
};
const prefsWndCompUpdateController = {
checkCompUpdates: function PrefsWndUpdController_checkCompUpdates() {
this._barApp = Preferences.barCore.application;
this._stringBundle = Preferences._stringBundle;
try {
this._barApp.updater.checkUpdates(this);
}
catch (e) {
this._logger.error(this._barApp.core.Lib.strutils.formatError(e));
this._logger.debug(e.stack);
}

}
,
start: function PrefsWndUpdController_start(updateProcess) {
this._barApp.updater.Interfaces.IUpdateProcess.checkImplementation(updateProcess);
this._logger.debug("PrefsWndUpdController_start");
this._updateProcess = updateProcess;
this._updateProcess.checkPresets();
this._state = "checking";
}
,
onPresetsDownloaded: function PrefsWndUpdController_onPresetsDownloaded(newDefPresetPair, newPresetPairs) {
this._newDefPresetPair = newDefPresetPair;
this._newPresetPairs = newPresetPairs;
this._updateProcess.checkUserPackagesUpdates(this._newPresetPairs);
}
,
onDefaultPresetUpdateFinish: function PrefsWndUpdController_onDefaultPresetUpdateFinish() {
this._logger.debug("Default preset update finished");
}
,
onUserComponentsDataReady: function DefaultController_onUserComponentsDataReady(presetUpdPairs, packageInfoList) {
if (! presetUpdPairs.length && ! packageInfoList.length)
{
this._logger.debug("No new components found. Update check finished.");
this._state = "up-to-date";
this._onUpdateDlgFinished(true);
return;
}

this._logger.debug(this._barApp.core.Lib.strutils.formatString("Found %1 new presets and %2 new manifests.",[presetUpdPairs.length, packageInfoList.length]));
this._newUserPresets = presetUpdPairs.map(function (pair) pair.newPreset);
this._packageInfoList = packageInfoList;
this._state = "confirm";
}
,
onUserComponentsUpdated: function PrefsWndUpdController_onUserComponentsUpdated() {
this._logger.warn("PrefsWndUpdController_onUserComponentsUpdated");
}
,
onUserConfirm: function DefaultController_onUserConfirm(fastInstall) {
document.documentElement.acceptDialog();
window.close();
Preferences.barCore.Lib.misc.openWindow({
url: "chrome://" + this._barApp.name + "/content/dialogs/package-management/update/update.xul",
features: "__popup__",
name: "package-management-update",
mode: "update",
presets: this._newUserPresets,
packageInfoList: this._packageInfoList,
application: this._barApp,
simple: fastInstall,
then: this._onUpdateDlgFinished.bind(this)});
}
,
set _state(state) {
this._updateBox.setAttribute("state",state);
this._activityLabel.value = this._stringBundle.get(this._activityDescr[state]);
}
,
get _updateBox() {
delete this._updateBox;
return this._updateBox = document.getElementById("check-updates-box");
}
,
get _activityLabel() {
delete this._activityLabel;
return this._activityLabel = document.getElementById("updates-activity-lbl");
}
,
get _logger() {
delete this._logger;
return this._logger = this._barApp.getLogger("ManualUpdater");
}
,
_DEF_PRESET_UPDATE_DELAY: 30000,
_activityDescr: {
"inactive": "UpdaterInactive",
"checking": "CheckingUpdates",
"up-to-date": "CompsUpToDate",
"confirm": "UpdatesFound"},
_onUpdateDlgFinished: function DefaultController__onUpdateDlgFinished(somethingUpdated) {
this._logger.debug("DefaultController__onUpdateDlgFinished");
if (somethingUpdated)
this._barApp.updater.resetUpdatesThrottling();
var sysutils = this._barApp.core.Lib.sysutils;
new sysutils.Timer(this._updateProcess.startSilentDefaultPresetUpdate.bind(this._updateProcess,this._newDefPresetPair), this._DEF_PRESET_UPDATE_DELAY, false);
}
};
var WidgetsControllerBase = {
_inited: false,
_listId: "Empty WidgetController._listId",
_list: null,
get list() {
return this._list || (this._list = document.getElementById(this._listId));
}
,
init: function WidgetsControllerBase_init() {
this.finalize();
this.list.PreferencesController = Preferences;
this._inited = true;
}
,
finalize: function WidgetsControllerBase_finalize() {
if (this._list)
{
this.list.clear();
this.list.PreferencesController = null;
this._list = null;
}

this._inited = false;
}
,
insertItem: function WidgetsControllerBase_insertItem(aWidgetProxy, aBeforeID) {
return this.list.insertItem(aWidgetProxy.isUnique,aWidgetProxy.isRemovable,aWidgetProxy.disabled,aWidgetProxy.protoId,aWidgetProxy.name,aWidgetProxy.iconURL,aBeforeID);
}
,
removeItem: function WidgetsControllerBase_removeItem(aProtoIdOrListItem) {
var listItem = aProtoIdOrListItem;
if (typeof listItem == "string")
listItem = document.getElementById(aProtoIdOrListItem);
if (listItem && listItem.parentNode == this.list)
{
this.list.removeItemFromSelection(listItem);
let indx = this.list.getIndexOfItem(listItem);
this.list.removeItemAt(indx);
}

}
};
var RegisteredWidgetsController = {
__proto__: WidgetsControllerBase,
_listId: "registered-widgets-list",
_list: null,
setWidgetVisibility: function RWL_setWidgetVisibility(aProtoID, aState) {
if (["hidden", "visible"].indexOf(aState) == - 1)
throw new Error("Unknown visibility state ('" + aState + "').");
var listitem = document.getElementById(aProtoID);
if (listitem)
{
let hidden = aState == "hidden";
listitem.hidden = hidden;
if (hidden)
this.list.removeItemFromSelection(listitem);
}

}
};
var RegisteredPluginsController = {
__proto__: WidgetsControllerBase,
_listId: "registered-plugins-list",
_list: null,
selectItem: function RPC_selectItem(aWidgetProxy) {
this.list.selectedItem = document.getElementById(aWidgetProxy.id);
}
,
switchItemState: function RPC_switchItemState(aPluginId) {
var plugin = RegisteredPlugins.get(aPluginId);
if (! plugin)
return;
var enabled = plugin.disabled;
plugin.disabled = ! plugin.disabled;
var pluginListitem = document.getElementById(plugin.id);
if (! pluginListitem)
return;
pluginListitem.enabled = enabled;
}
,
initItemSettings: function RPC_initItemSettings(aItem) {
var plugin = RegisteredPlugins.get(aItem.id);
if (plugin)
this._initItemSettings(aItem,plugin);
}
,
_initItemSettings: function RPC__initItemSettings(aItem, aWidget) {
var settingsXULDocument = aWidget.settingsXULDocument;
var nativeNodesData = SettingsDocumentHelper.createNativeNodes(document,settingsXULDocument,aItem);
if (aWidget.isXbWidget)
{
for(let [name, controlInfo] in Iterator(aWidget.instanceSettings)) {
if (this._appendNamedNodes(nativeNodesData,aItem,name,"instance",aWidget,controlInfo))
continue;
let element = this._createSettingUI(aWidget,name,controlInfo);
if (! element)
continue;
aItem.appendChild(element);
}

let uniqueWidget = aWidget.isUnique;
for(let [name, controlInfo] in Iterator(aWidget.protoSettings)) {
if (this._appendNamedNodes(nativeNodesData,aItem,name,"proto",aWidget,controlInfo))
continue;
let element = this._createSettingUI(aWidget,name,controlInfo);
if (! element)
continue;
if (! uniqueWidget)
{
element.setAttribute("xb-global-setting-warning","auto");
element.setAttribute("xb-global-setting-names",aWidget.name);
}

aItem.appendChild(element);
}

for(let [name, controlInfo] in Iterator(aWidget.packageSettings)) {
if (this._appendNamedNodes(nativeNodesData,aItem,name,"package",aWidget,controlInfo))
continue;
let element = this._createSettingUI(aWidget,name,controlInfo);
if (! element)
continue;
let affectedWidgetIDs = aWidget.unitPackage.getSettingUsers(name);
let affectedWidgetNames = [];
try {
affectedWidgetNames = affectedWidgetIDs.map(function getName(widgetProtoID) {
return this.getComponentInfo(widgetProtoID).name;
}
,Preferences.barCore.application.widgetLibrary);
}
catch (e) {
Preferences._logger.error(e);
}

element.setAttribute("xb-global-setting-warning","auto");
element.setAttribute("xb-global-setting-names",affectedWidgetNames.join());
aItem.appendChild(element);
}

}

nativeNodesData.appendNodes(aItem);
aWidget.updatePreferenceNodes(document);
}
,
_appendNamedNodes: function RPC__appendNamedNodes(aNativeNodesData, aItem, aSettingName, aSettingType, aWidget, aControlInfo) {
if (! aNativeNodesData.hasNamedNode(aSettingName))
return false;
var prefPath;
var defaultValue = aControlInfo && aControlInfo.defaultValue;
try {
let nativeComponents = Preferences.barCore.application.NativeComponents;
switch (aSettingType) {
case "instance":
prefPath = nativeComponents.makeInstancePrefPath(aWidget.protoId,aWidget.instanceID,aSettingName);
break;
case "proto":
prefPath = nativeComponents.makeWidgetPrefPath(aWidget.protoId,aSettingName);
break;
case "package":
prefPath = nativeComponents.makePackagePrefPath(aWidget.unitPackage.id,aSettingName);
break;
default:
throw new Error("Wrong setting type.");
}

}
catch (e) {
Preferences._logger.error(e);
}

return aNativeNodesData.appendNamedNodes(aItem,aSettingName,prefPath,defaultValue);
}
,
_createSettingUI: function RPC__createSettingUI(aWidget, aSettingName, aControlInfo) {
var control = Preferences.transformControlXML(aControlInfo.controlElement);
if (! control)
return null;
control.setAttribute("prefName",aSettingName);
["source", "alt-source", "template", "alt-template", "shortcuts-source", "shortcuts-alt-source", "shortcuts-template", "shortcuts-alt-template"].forEach(function (aAttrName) {
if (control.hasAttribute(aAttrName))
{
let url = aWidget.makeURL(control.getAttribute(aAttrName));
if (url)
{
control.setAttribute(aAttrName,url);
}
 else
{
control.removeAttribute(aAttrName);
}

}

}
,this);
var settingValue = this._getProxiedSettingValue(aWidget,aSettingName);
if (typeof settingValue != "undefined")
control.setAttribute("value",settingValue);
return control;
}
,
_getProxiedSettingValue: function RPC__getProxiedSettingValue(aWidget, aSettingName) {
var value = SettingsProxy.recall(aWidget.id,aSettingName);
if (typeof value == "undefined")
value = aWidget.xbWidget.getSettingValue(aSettingName);
return value;
}
,
_executeOnDialogAction: function RWL__executeOnDialogAction(aActionName) {
if (! this._list)
return;
Array.slice(this._list.querySelectorAll("richlistitem[" + aActionName + "]")).forEach(function (aActionNode) {
try {
(new Function(aActionNode.getAttribute(aActionName)))();
}
catch (ex) {
Preferences._logger.error(ex);
}

}
);
}
,
onDialogApply: function RWL_onDialogApply() {
this._executeOnDialogAction("onSettingsApply");
}
,
onDialogCancel: function RWL_onDialogCancel() {
this._executeOnDialogAction("onSettingsCancel");
}
,
onDialogReset: function RWL_onDialogReset() {
this._executeOnDialogAction("onSettingsReset");
}
};
var ActiveWidgetsController = {
__proto__: RegisteredPluginsController,
_listId: "active-widgets-list",
_list: null,
insertItem: function AWL_insertItem(aWidgetProxy, aBeforeID) {
if (aWidgetProxy.isUnique)
RegisteredWidgetsController.setWidgetVisibility(aWidgetProxy.protoId,"hidden");
return this.list.insertItem(aWidgetProxy.isUnique,aWidgetProxy.isRemovable,aWidgetProxy.disabled,aWidgetProxy.id,aWidgetProxy.name,aWidgetProxy.iconURL,aBeforeID);
}
,
moveSelectedItems: function AWL_moveSelectedItems(aDirection, aBeforeElementId) {
return this.list.moveSelectedItems(aDirection,aBeforeElementId);
}
,
getItemsForProto: function AWL_getItemsForProto(aWidgetProtoID) {
return Array.slice(this.list.childNodes).filter(function (aItem) {
var widget = ActiveWidgets.get(aItem.id);
return ! ! (widget && widget.protoId == aWidgetProtoID);
}
);
}
,
initItemSettings: function AWL_initItemSettings(aItem) {
var widget = ActiveWidgets.get(aItem.id);
if (widget)
this._initItemSettings(aItem,widget);
}
};
var WidgetNodesMutationListener = {
handleEvent: function WNML_handleEvent(aEvent) {
if (aEvent.target.localName != "toolbaritem" || aEvent.target.getAttribute("cb-app") != XB_APP_NAME)
return;
var relatedNode = aEvent.relatedNode;
if (! relatedNode)
return;
switch (relatedNode.localName) {
case "toolbar":
setTimeout(function (aSelf, aEvent) {
aSelf._onToolbarMutation(aEvent);
}
,0,this,aEvent);
break;
case "toolbarpalette":
setTimeout(function (aSelf, aEvent) {
aSelf._onPaletteMutation(aEvent);
}
,0,this,aEvent);
break;
}

}
,
_onPaletteMutation: function WNML_onPaletteMutation(aEvent) {
var protoID = aEvent.target.getAttribute("cb-proto-id");
if (! protoID)
return;
var paletteItemID = Preferences.barCore.application.overlayProvider.compileWidgetItemId(protoID,0);
var paletteItemExists = ! ! aEvent.relatedNode.getElementsByAttribute("id",paletteItemID).length;
switch (aEvent.type) {
case "DOMNodeInserted":
try {
if (paletteItemExists && ! RegisteredWidgets.get(protoID))
RegisteredWidgets.push(protoID);
}
catch (e) {
Preferences._logger.error("Can't add widget to registered widgets. " + Preferences.barCore.Lib.strutils.formatError(e));
Preferences._logger.debug(e.stack);
}

break;
case "DOMNodeRemoved":
if (! paletteItemExists)
RegisteredWidgetsController.setWidgetVisibility(protoID,"hidden");
break;
}

}
,
_onToolbarMutation: function WNML_onToolbarMutation(aEvent) {
var target = aEvent.target;
var toolbaritemId = target.id;
var activeWidget = ActiveWidgets.get(toolbaritemId);
switch (aEvent.type) {
case "DOMNodeInserted":
if (! activeWidget && target.parentNode)
{

}

break;
case "DOMNodeRemoved":
if (activeWidget && ! target.parentNode)
{
ActiveWidgetsController.removeItem(toolbaritemId);
let widget = ActiveWidgets.remove(toolbaritemId);
RegisteredWidgetsController.setWidgetVisibility(widget.protoId,"visible");
}

break;
}

}
};
window.__defineSetter__("JSInstObject",function () {
Preferences._logger.error("Can't use JSInstObject for plugins.");
}
);
window.addEventListener("load",Preferences,false);
window.addEventListener("paneload",Preferences,false);
